/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#include "CMainWindow.h"
#include "ui_CMainWindow.h"

#include "CWrapperClassLayer.h"
#include <QMessageBox>

struct CMainWindowData
{
    Ui::CMainWindow ui;
};

CMainWindow::CMainWindow()
{
    d = new CMainWindowData;
    d->ui.setupUi(this);

    connect( &CWrapperCanvas::instance(), SIGNAL(wrapperSelected(QObject*)),
             d->ui.propertyEditor, SLOT(setObject(QObject*)));
}

CMainWindow::~CMainWindow()
{
    delete d;
}

void CMainWindow::on_action_Quit_triggered()
{
    qApp->quit();
}

void CMainWindow::on_actionAbout_triggered()
{
    QMessageBox::information(this, "About", 
        "Simple VTK Pipeline Designer\n"
        "Demo Code for Designing_Visual_Editors_in_Qt Article\n"
        "\n"
        "Copyright: Prashanth N Udupa, VCreate Logic\n"
        "           prashanth @ vcreatelogic . com\n"
        "           www.vcreatelogic.com\n");
}

