/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#ifndef C_WRAPPER_CANVAS_VIEW_H
#define C_WRAPPER_CANVAS_VIEW_H

#include <QGraphicsView>

class CWrapperCanvas;

struct CWrapperCanvasViewData;
class CWrapperCanvasView : public QGraphicsView
{
    Q_OBJECT

public:
    CWrapperCanvasView(QWidget* parent=0);
    ~CWrapperCanvasView();

    void setWrapperCanvas(CWrapperCanvas* canvas);
    CWrapperCanvas* wrapperCanvas() const;

    int zoomLevel() const;
    double zoomScale() const;

public slots:
    void setZoomLevel(int zoomLevel);
    void zoomIn();
    void zoomOut();
    void zoomFull();
    void zoomOne();
    void zoomFit();
    void printToPDF(const QString fileName=QString());

signals:
    void zoomLevelChanged(int zl);
    void zoomScaleChanged(double zs);

protected:
    void mousePressEvent(QMouseEvent* e);
    void mouseMoveEvent(QMouseEvent* e);
    void mouseReleaseEvent(QMouseEvent* e);
    void resizeEvent(QResizeEvent* re);
    void wheelEvent(QWheelEvent * e);
    void drawBackground(QPainter * painter, const QRectF & rect);

private:
    CWrapperCanvasViewData* d;
};

#endif

