/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#ifndef C_WRAPPER_CLASS_SELECTION_LIST_H
#define C_WRAPPER_CLASS_SELECTION_LIST_H

#include <QTreeWidget>
#include <QDrag>

struct CWrapperClassSelectionListData;
class CWrapperClassSelectionList : public QTreeWidget
{
    Q_OBJECT

public:
    CWrapperClassSelectionList(QWidget* parent);
    ~CWrapperClassSelectionList();

protected:
    void mousePressEvent(QMouseEvent* me);
    void mouseMoveEvent(QMouseEvent* me);
    void drawBranches(QPainter* , const QRect &, const QModelIndex &) const { }

private:
    CWrapperClassSelectionListData* d;
};

class CWrapperClassSelectionListDragObject : public QDrag
{
public:
    static bool canDecode(const QMimeData* mimeData);
    static bool decode(const QMimeData* mimeData, QString & className);

    CWrapperClassSelectionListDragObject(QWidget* source, const QString className);
};

#endif

