/*=========================================================================
  This module is an extension of the "Visualization Toolkit 
  ( copyright (c) 1993-2000 Ken Martin, Will Schroeder, Bill Lorensen )".
  and combines it with "Qt (copyright (C) 1992-2000 Troll Tech AS)".
  =========================================================================
  vtkQt - copyright 2000 Matthias Koenig 
  koenig@isg.cs.uni-magdeburg.de
  http://wwwisg.cs.uni-magdeburg.de/~makoenig
  =========================================================================
  vtkQt Classes modified for VTK Editor Demo by Prashanth N Udupa
  VCreate Logic, Bangalore. EMail: prashanth @ vcreatelogic . com
  =========================================================================
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:
  
  * Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.
   
  * Redistributions in binary form must reproduce the above copyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
   
  * Modified source versions must be plainly marked as such, and must not be
  misrepresented as being the original software.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
  ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  =========================================================================*/

#ifndef _CVtkQtRenderWindowInteractor_h
#define _CVtkQtRenderWindowInteractor_h

#include "vtkCommand.h"
#include "vtkInteractorStyle.h"
#include "vtkRenderWindowInteractor.h"

#include "CVtkQtRenderWindow.h"
#include <QObject>
#include <QTimer>
#include <QCursor>
//Added by qt3to4:
#include <QMouseEvent>
#include <QKeyEvent>

class VTK_QT_EXPORT CVtkQtRenderWindowInteractor:public QObject,
public vtkRenderWindowInteractor
{
    Q_OBJECT friend class CVtkQtRenderWindow;
    public:
        vtkTypeMacro(CVtkQtRenderWindowInteractor, vtkRenderWindowInteractor);
        CVtkQtRenderWindowInteractor();
        ~CVtkQtRenderWindowInteractor();
        // inline
        static CVtkQtRenderWindowInteractor *New();
        void PrintSelf(ostream & os, vtkIndent indent);

        void Start();

        void SetRenderWindow(CVtkQtRenderWindow *);

        // timer methods
        int CreateTimer(int timertype);
        int DestroyTimer(void);

        // own exit method
        void ExitCallback();  // inline

    protected slots: void timer();
    protected:
        void mousePressEvent(QMouseEvent *);
        void mouseReleaseEvent(QMouseEvent *);
        void mouseMoveEvent(QMouseEvent *);
        void keyPressEvent(QKeyEvent *);
    private:
        CVtkQtRenderWindow * qtRenWin;
        QTimer qTimer;
};

inline CVtkQtRenderWindowInteractor *CVtkQtRenderWindowInteractor::New()
{
    return new CVtkQtRenderWindowInteractor;
}


inline void CVtkQtRenderWindowInteractor::ExitCallback()
{
    qApp->exit();
}
#endif
