/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#include "CVtkConeSourceWrapper.h"
#include "vtkConeSource.h"
#include "vtkPolyData.h"

CVtkConeSourceWrapper::CVtkConeSourceWrapper()
{
    _vtkConeSource = vtkConeSource::New();
    setVtkObject(_vtkConeSource);
}

CVtkConeSourceWrapper::~CVtkConeSourceWrapper()
{
    // do nothing.
}

void CVtkConeSourceWrapper::setBaseRadius(double rad)
{
    _vtkConeSource->SetRadius(rad);
}

double CVtkConeSourceWrapper::baseRadius() const
{
    return _vtkConeSource->GetRadius();
}

void CVtkConeSourceWrapper::setHeight(double height)
{
    _vtkConeSource->SetHeight(height);
}

double CVtkConeSourceWrapper::height() const
{
    return _vtkConeSource->GetHeight();
}

void CVtkConeSourceWrapper::setResolution(int res)
{
    _vtkConeSource->SetResolution(res);
}

int CVtkConeSourceWrapper::resolution() const
{
    return _vtkConeSource->GetResolution();
}

int CVtkConeSourceWrapper::outputLinkCount() const
{
    return 1;
}

CWrapperLinkDesc CVtkConeSourceWrapper::outputLinkDesc(int index) const
{
    CWrapperLinkDesc desc;

    if(index == 0)
    {
        desc.linkName = "ConeData";
        desc.linkDataType = POLY_DATA_TYPE;
    }

    return desc;
}

bool CVtkConeSourceWrapper::getOutput(int index, CWrapperLinkData & output)
{
    if(index)
        return false;
    output.data.dataObject = _vtkConeSource->GetOutput();
    return true;
}

