/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#ifndef C_VTK_CONE_SOURCE_WRAPPER_H
#define C_VTK_CONE_SOURCE_WRAPPER_H

#include "CWrapperClassLayer.h"

class vtkConeSource;
class CVtkConeSourceWrapper : public CWrapper
{
    Q_OBJECT
    Q_PROPERTY(double BaseRadius READ baseRadius WRITE setBaseRadius)
    Q_PROPERTY(double Height READ height WRITE setHeight)
    Q_PROPERTY(int Resolution READ resolution WRITE setResolution)

public:
    CVtkConeSourceWrapper();
    ~CVtkConeSourceWrapper();

    void setBaseRadius(double rad);
    double baseRadius() const;

    void setHeight(double height);
    double height() const;

    void setResolution(int res);
    int resolution() const;

    int outputLinkCount() const;
    CWrapperLinkDesc outputLinkDesc(int index) const;

protected:
    bool getOutput(int index, CWrapperLinkData & output);

private:
    vtkConeSource* _vtkConeSource;
};

#endif
