/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#include "CVtkPolyDataMapper.h"
#include "vtkPolyDataMapper.h"
#include "vtkPolyData.h"

CVtkPolyDataMapper::CVtkPolyDataMapper()
{
    _vtkPolyDataMapper = vtkPolyDataMapper::New();
    setVtkObject(_vtkPolyDataMapper);
}

CVtkPolyDataMapper::~CVtkPolyDataMapper()
{

}

int CVtkPolyDataMapper::inputLinkCount() const
{
    return 1;
}

CWrapperLinkDesc CVtkPolyDataMapper::inputLinkDesc(int index) const
{
    CWrapperLinkDesc desc;

    if(!index)
    {
        desc.linkName = "PolyData";
        desc.linkDataType = POLY_DATA_TYPE;
    }

    return desc;
}

int CVtkPolyDataMapper::outputLinkCount() const
{
    return 1;
}

CWrapperLinkDesc CVtkPolyDataMapper::outputLinkDesc(int index) const
{
    CWrapperLinkDesc desc;

    if(!index)
    {
        desc.linkName = "Mapper";
        desc.linkDataType = MAPPER_TYPE;
    }

    return desc;
}

bool CVtkPolyDataMapper::hasInput(int index)
{
    if(index)
        return false;

    return _vtkPolyDataMapper->GetInput() != 0;
}

bool CVtkPolyDataMapper::setInput(int index, const CWrapperLinkData & linkData)
{
    if(index)
        return false;

    vtkPolyData* pd = dynamic_cast<vtkPolyData*>(linkData.data.dataObject);
    if(!pd)
        return false;

    _vtkPolyDataMapper->SetInput(pd);
    return true;
}

bool CVtkPolyDataMapper::removeInput(int index, const CWrapperLinkData & linkData)
{
    if(index)
        return false;

    vtkPolyData* pd = dynamic_cast<vtkPolyData*>(linkData.data.dataObject);
    if(!pd || pd != _vtkPolyDataMapper->GetInput())
        return false;

    _vtkPolyDataMapper->SetInput(0);
    return true;
}

bool CVtkPolyDataMapper::getOutput(int index, CWrapperLinkData & output)
{
    if(index)
        return false;

    output.data.mapper = _vtkPolyDataMapper;
    return true;
}


