/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#ifndef C_VTK_POLYDATA_MAPPER_H
#define C_VTK_POLYDATA_MAPPER_H

#include "CWrapperClassLayer.h"

class vtkPolyDataMapper;
class CVtkPolyDataMapper: public CWrapper
{
    Q_OBJECT

public:
    CVtkPolyDataMapper();
    ~CVtkPolyDataMapper();

    int inputLinkCount() const;
    CWrapperLinkDesc inputLinkDesc(int index) const;

    int outputLinkCount() const;
    CWrapperLinkDesc outputLinkDesc(int index) const;

protected:
    bool hasInput(int index);
    bool setInput(int index, const CWrapperLinkData & linkData);
    bool removeInput(int index, const CWrapperLinkData & linkData);
    bool getOutput(int index, CWrapperLinkData & output);

private:
    vtkPolyDataMapper* _vtkPolyDataMapper;
};

#endif
