/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#include "CVtkPolyDataNormals.h"
#include "vtkPolyDataNormals.h"
#include "vtkPolyData.h"

CVtkPolyDataNormals::CVtkPolyDataNormals()
{
    _vtkPolyDataNormals = vtkPolyDataNormals::New();
    setVtkObject(_vtkPolyDataNormals);
}

CVtkPolyDataNormals::~CVtkPolyDataNormals()
{

}

int CVtkPolyDataNormals::inputLinkCount() const
{
    return 1;
}

CWrapperLinkDesc CVtkPolyDataNormals::inputLinkDesc(int index) const
{
    CWrapperLinkDesc desc;

    if(!index)
    {
        desc.linkName = "PolyData";
        desc.linkDataType = POLY_DATA_TYPE;
    }

    return desc;
}

int CVtkPolyDataNormals::outputLinkCount() const
{
    return 1;
}

CWrapperLinkDesc CVtkPolyDataNormals::outputLinkDesc(int index) const
{
    CWrapperLinkDesc desc;

    if(!index)
    {
        desc.linkName = "PolyData";
        desc.linkDataType = POLY_DATA_TYPE;
    }

    return desc;
}

bool CVtkPolyDataNormals::hasInput(int index)
{
    if(index)
        return false;

    return _vtkPolyDataNormals->GetInput() != 0;
}

bool CVtkPolyDataNormals::setInput(int index, const CWrapperLinkData & linkData)
{
    if(index)
        return false;

    vtkPolyData* pd = dynamic_cast<vtkPolyData*>(linkData.data.dataObject);
    if(!pd)
        return false;

    _vtkPolyDataNormals->SetInput(pd);
    return true;
}

bool CVtkPolyDataNormals::removeInput(int index, const CWrapperLinkData & linkData)
{
    if(index)
        return false;

    vtkPolyData* pd = dynamic_cast<vtkPolyData*>(linkData.data.dataObject);
    if(!pd)
        return false;

    if(_vtkPolyDataNormals->GetInput() != pd)
        return false;

    _vtkPolyDataNormals->SetInput(0);
    return true;
}

bool CVtkPolyDataNormals::getOutput(int index, CWrapperLinkData & output)
{
    if(index)
        return false;

    output.data.dataObject = _vtkPolyDataNormals->GetOutput();
    return true;
}

