/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#include "CVtkRenderWindow.h"
#include "CVtkQtRenderWindow.h"
#include "CVtkQtRenderWindowInteractor.h"
#include "vtkRendererCollection.h"

CVtkRenderWindow::CVtkRenderWindow()
{
    CVtkQtRenderWindow* rWin = new CVtkQtRenderWindow(0);
    CVtkQtRenderWindowInteractor* rWinInt = new CVtkQtRenderWindowInteractor();

    rWinInt->SetRenderWindow(rWin);
    rWinInt->Initialize();
    rWinInt->Start();

    _vtkRenderWindow = rWin;
    setVtkObject(_vtkRenderWindow);

    rWin->show();
}

CVtkRenderWindow::~CVtkRenderWindow()
{
    _vtkRenderWindow->SetInteractor(0);
    CVtkQtRenderWindow* rWin = dynamic_cast<CVtkQtRenderWindow*>(_vtkRenderWindow);
    setVtkObject(0);
    delete rWin;
}

int CVtkRenderWindow::inputLinkCount() const
{
    return 1;
}

CWrapperLinkDesc CVtkRenderWindow::inputLinkDesc(int index) const
{
    CWrapperLinkDesc desc;

    if(!index)
    {
        desc.linkName = "Renderer";
        desc.linkDataType = RENDERER_TYPE;
        // desc.acceptMultipleInputs = true;
        // lets keep this false for now.
    }

    return desc;
}

bool CVtkRenderWindow::hasInput(int index)
{
    if(index)
        return false;

    return _vtkRenderWindow->GetRenderers()->GetNumberOfItems() != 0;
}

bool CVtkRenderWindow::setInput(int index, const CWrapperLinkData & linkData)
{
    if(index)
        return false;

    _vtkRenderWindow->AddRenderer(linkData.data.renderer);
    _vtkRenderWindow->Render();
    return true;
}

bool CVtkRenderWindow::removeInput(int index, const CWrapperLinkData & linkData)
{
    if(index)
        return false;

    _vtkRenderWindow->RemoveRenderer(linkData.data.renderer);
    linkData.data.renderer->SetRenderWindow(0);
    return true;
}

