/************************************************************************
Demo Code for Designing_Visual_Editors_in_Qt Article

Copyright (C) 2004-2007  Prashanth N Udupa, (prashanth @ vcreatelogic . com)
        VCreate Logic Private Limited, Bangalore

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
version 2 as published by the Free Software Foundation

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License Version 2 for more details.

You should have received a copy of the GNU General Public License
Version 2 along with this program; if not, write to the Free
Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
MA  02111-1307  USA
************************************************************************/

#include "CVtkRenderer.h"
#include "vtkRenderer.h"
#include "vtkActorCollection.h"

CVtkRenderer::CVtkRenderer()
{
    _vtkRenderer = vtkRenderer::New();
    setVtkObject(_vtkRenderer);
}

CVtkRenderer::~CVtkRenderer()
{

}

int CVtkRenderer::inputLinkCount() const
{
    return 1;
}

CWrapperLinkDesc CVtkRenderer::inputLinkDesc(int index) const
{
    CWrapperLinkDesc desc;

    if(!index)
    {
        desc.linkName = "Actor";
        desc.linkDataType = ACTOR_TYPE;
        desc.acceptMultipleInputs = true;
    }

    return desc;
}

int CVtkRenderer::outputLinkCount() const
{
    return 1;
}

CWrapperLinkDesc CVtkRenderer::outputLinkDesc(int index) const
{
    CWrapperLinkDesc desc;

    if(!index)
    {
        desc.linkName = "Renderer";
        desc.linkDataType = RENDERER_TYPE;
    }

    return desc;
}

bool CVtkRenderer::hasInput(int index)
{
    if(index)
        return false;

    return _vtkRenderer->GetActors()->GetNumberOfItems() != 0;
}

bool CVtkRenderer::setInput(int index, const CWrapperLinkData & linkData)
{
    if(index)
        return false;

    _vtkRenderer->AddActor(linkData.data.actor);
    return true;
}

bool CVtkRenderer::removeInput(int index, const CWrapperLinkData & linkData)
{
    if(index)
        return false;

    _vtkRenderer->RemoveActor(linkData.data.actor);
    return true;
}

bool CVtkRenderer::getOutput(int index, CWrapperLinkData & output)
{
    if(index)
        return false;

    output.data.renderer = _vtkRenderer;
    return true;
}


